
Import "Trails.bmx"

AppTitle = "Trail Editor"

Global trailFile$ = RequestFile("Trail Info", "tinfo")

If Not(trailFile) End

Global lastModded = FileTime(trailFile)

Global tinfo:trailInfo = trailInfo.Load(trailFile)


Graphics 800, 600, 0


spinner:trail = New trail;
mouseFollower:trail = New trail;

spinner.info = tinfo;
mouseFollower.info = tinfo;

Global rot#, rotV# = 90, width# = 32

Global deltaT#, lasttime = MilliSecs()
While Not(KeyHit(key_escape))
	deltaT = (MilliSecs()-lasttime)*.001; lasttime = MilliSecs()
	
	spinner.addPoint(GraphicsWidth()*.5+Cos(rot)*(260-width), GraphicsHeight()*.5+Sin(rot)*(260-width),..
	 GraphicsWidth()*.5+Cos(rot)*260, GraphicsHeight()*.5+Sin(rot)* 260)
	mouseFollower.addPoint(MouseX(), MouseY(), MouseX(), MouseY())
	
	spinner.update(deltaT#)
	mouseFollower.update(deltaT#)
	
	spinner.draw()
	mouseFollower.draw()
	
	time = FileTime(trailFile)
	If time <> lastModded Then
		Print "RELOADED INFO"
		lastModded = time
		tinfo:trailInfo = trailInfo.Load(trailFile)
		mouseFollower.info = tinfo;
		spinner.info = tinfo;
	End If
	
	If KeyHit(key_space) Then
		Print "RESET TRAILS"
		spinner:trail = New trail;
		mouseFollower:trail = New trail;
		mouseFollower.info = tinfo;
		spinner.info = tinfo;
	End If
	
	SetAlpha(1)
	SetColor(255,255,255)
	DrawText("up down left right space escape", 0, 0)
	
	If KeyHit(key_up) Then width:+ 10
	If KeyHit(key_down) Then width:- 10
	If KeyHit(key_left) Then rotv:-60
	If KeyHit(key_right) Then rotv:+60
	
	rot:+ rotv*deltaT
	
	Flip; Cls;
Wend