
Rem
Graphics 1680, 1000, 0

n:trail = New trail
n.info = trailinfo.Load(RequestFile("COCK", "tinfo", 0, "../Escort Wing/Data/Trail Infos/"))

While Not(KeyHit(key_escape))
	
	n.addPoint(MouseX(), MouseY(), MouseX(), MouseY()+40, 0, 0)
	n.update(.01)
	n.draw()
	
	Flip; Cls
Wend
End Rem


Type trail
	
	Field info:trailinfo
	
	Field activeSeg:trailsegment
	Field segs:TList
	
	Field oneSeg=1
	
	Field lastX#, lastY#
	
	Field segCreationCounter
	
	Method New()
		segs = CreateList()
	End Method
	
	Method addPoint(lx#, ly#, rx#, ry#, vx#=0, vy#=0)
		If activeSeg = Null Then
			activeSeg = newTS(rx, ry, lx, ly)
			n:trailSegment = newTS(rx, ry, lx, ly)
			ListAddLast(segs, n)
			lastX = (rx+lx)*.5; lastY = (ry+ly)*.5
			
			segCreationCounter:+1
		Else
			If oneSeg = 1 Then
				oneSeg = 0
				For i:trailSegment = EachIn segs
					setSegVelocity(i, lx, ly, rx, ry, vx, vy)
				Next
			End If
			If (lastx - (rx+lx)*.5)^2 + (lasty - (ry+ly)*.5)^2 < info.sectionLength^2 Then
				activeSeg.setPos(lx, ly, rx, ry)
			Else
				
				setSegVelocity(activeSeg, lx, ly, rx, ry, vx, vy)
				
				ListAddFirst(segs, activeSeg)
				
				activeSeg = newTS(lx, ly, rx, ry)
				
				lastX = (rx+lx)*.5; lastY = (ry+ly)*.5
				segCreationCounter:+1
				
			End If
		End If
	End Method
	
	Method setSegVelocity(s:trailsegment, lx#, ly#, rx#, ry#, vx#=0, vy#=0)
		dir# = ATan2(((ry+ly)*.5)-lasty, ((rx+lx)*.5)-lastx)
		spreadv# = info.spread + Rnd(0, info.rspread)
		s.setv(Cos(dir-90)*spreadV+Rand(-info.randv*.5, info.randv*.5) + vx,..
		 Sin(dir-90)*spreadV+Rand(-info.randv*.5, info.randv*.5) + vy,..
		 Cos(dir+90)*spreadV+Rand(-info.randv*.5, info.randv*.5) + vx,..
		 Sin(dir+90)*spreadV+Rand(-info.randv*.5, info.randv*.5) + vy)
	End Method
	
	Method newTS:trailSegment(lx#, ly#, rx#, ry#)
		n:trailSegment = New trailSegment
		n.a = info.a + Rnd(0, info.ra); n.va = info.va + Rnd(0, info.rva)
		n.r = info.r + Rnd(0, info.rr); n.g = info.g + Rnd(0, info.rg); n.b = info.b + Rnd(0, info.rb)
		n.vr = info.vr + Rnd(0, info.rvr); n.vg = info.vg + Rnd(0, info.rvg); n.vb = info.vb + Rnd(0, info.rvb)
		n.setPos(lx, ly, rx, ry)
		Return n
	End Method
	
	Method update(deltaT#)
		If activeSeg <> Null Then activeSeg.update(deltaT)
		For i:trailSegment = EachIn segs
			i.update(DeltaT)
		Next
		
		
		ReverseList(segs)
		For i:trailSegment = EachIn segs
			If i.a <= 0 Then
				ListRemove(segs, i)
			Else
				Exit
			End If
		Next
		ReverseList(segs)
	End Method
	
	Method draw()
		SetBlend(info.blendmode)
		f:trailSegment = activeSeg
		For i:trailSegment = EachIn segs
			SetColor(f.r, f.g, f.b)
			SetAlpha(f.a)
			DrawPoly([f.lx, f.ly, f.rx, f.ry, i.rx, i.ry, i.lx, i.ly])
			f = i;
		Next
	End Method
	
End Type




Type trailSegment
	
	Field a#, va#
	
	Field r#, g#, b#
	Field vr#, vg#, vb#
	
	Field lx#, ly#, rx#, ry#
	Field vlx#, vly#, vrx#, vry#
	
	Field closing, closed
	
	Method setpos(llx#, lly#, rrx#, rry#)
		lx = llx; ly = lly; rx = rrx; ry = rry
	End Method
	
	Method setv(vvlx#, vvly#, vvrx#, vvry#)
		vlx = vvlx; vly = vvly; vrx = vvrx; vry = vvry
	End Method
	
	Method update(deltaT#)
		a:+ va* deltaT
		r:+ vr* deltaT
		g:+ vg* deltaT
		b:+ vb* deltaT
		
		If a > 1 Then a = 1; If a < 0 Then a = 0
		If r > 255 Then r = 255; If r < 0 Then r = 0
		If g > 255 Then g = 255; If g < 0 Then g = 0
		If b > 255 Then b = 255; If b < 0 Then b = 0
		
		d1# = (lx-rx)^2 + (ly-ry)^2
		
		lx:+ vlx*deltaT
		ly:+ vly*deltaT
		rx:+ vrx*deltaT
		ry:+ vry*deltaT
		
		d2# = (lx-rx)^2 + (ly-ry)^2
		
		If Not(closing) Then
			If d2 < d1 Then
				closing = 1
			End If
		Else
			If d2 > d1 Then
				closed = 1
				lx = (rx+lx)*.5; ly = (ry+ly)*.5
				rx = lx; ry = ly
				vlx = (vrx+vlx)*.5; vly = (vry+vly)*.5
				vrx = vlx; vry = vly
			End If
		End If
		
	End Method
	
End Type





Type trailInfo
	
	
	Global allInfos:TList
	
	
	Function LoadFromDir(dir$)
		If allInfos = Null Then allInfos = CreateList()

		Local files$[]
		files=LoadDir(dir)
		
		For t$ = EachIn files
			If ExtractExt(t).contains("tinfo") Then ListAddLast(allInfos, trailInfo.Load(Dir + "/" + t))
		Next
	End Function
	
	
	Function Load:trailinfo(dir$)
		
		s:TStream = OpenFile(dir)
		If s = Null Then Return
		
		n:trailInfo = New trailInfo
		
		While Not(Eof(s))
			
			Select ReadLine(s)
				Case "Name:"
					n.name = ReadLine(s)
				Case "RGB:"
					n.r = Float(ReadLine(s))
					n.g = Float(ReadLine(s))
					n.b = Float(ReadLine(s))
				Case "Random RGB:"
					n.rr = Float(ReadLine(s))
					n.rg = Float(ReadLine(s))
					n.rb = Float(ReadLine(s))
				Case "RGB Velocity:"
					n.vr = Float(ReadLine(s))
					n.vg = Float(ReadLine(s))
					n.vb = Float(ReadLine(s))
				Case "Random RGB Velocity:"
					n.rvr = Float(ReadLine(s))
					n.rvg = Float(ReadLine(s))
					n.rvb = Float(ReadLine(s))
				Case "Alpha:"
					n.a = Float(ReadLine(s))
				Case "Random Alpha:"
					n.ra = Float(ReadLine(s))
				Case "Alpha Velocity:"
					n.va = Float(ReadLine(s))
				Case "Random Alpha Velocity:"
					n.rva = Float(ReadLine(s))
				Case "Blend Mode:"
					n.blendmode = Int(ReadLine(s))
				Case "Spread Velocity:"
					n.spread = Float(ReadLine(s))
				Case "Random Spread Velocity:"
					n.rspread = Float(ReadLine(s))
				Case "Random Velocity:"
					n.randv = Float(ReadLine(s))
				Case "Section Length:"
					n.sectionLength = Float(ReadLine(s))
			End Select
			
		Wend
		
		Print "LOADED: " + n.name
		
		CloseFile(s)
		
		Return n
		
	End Function
	
	
	Function named:trailInfo(name$)
		If allInfos = Null Then Notify("No trail infos!", True)
		For i:trailInfo = EachIn allInfos
			If i.name = name Then Return i
		Next
		Notify("No such trail info found! (" + name + ")", True)
	End Function
	
	
	Field name$
	
	Field blendMode = ALPHABLEND
	
	Field r#=255, g#=255, b#=255
	Field rr#, rg#, rb#
	Field vr#, vg#, vb#
	Field rvr#, rvg#, rvb#
	
	Field a#=1, va#=-1, ra#, rva#
	
	Field spread#, rSpread#
	Field randV#
	
	Field sectionLength#=15
	
End Type

